package model

import (
	"gorm.io/gorm"
	"time"
)

type FsCart struct {
	Id         int64      `gorm:"primary_key" json:"id"` // id
	UserId     *int64     `gorm:"" json:"user_id"`       // 用户ID
	ProductId  *int64     `gorm:"" json:"product_id"`    // 产品ID
	TemplateId *int64     `gorm:"" json:"template_id"`   // 模板ID
	PriceId    *int64     `gorm:"" json:"price_id"`      // 价格ID
	MaterialId *int64     `gorm:"" json:"material_id"`   // 材质ID
	SizeId     *int64     `gorm:"" json:"size_id"`       // 尺寸ID
	BuyNum     *int64     `gorm:"" json:"buy_num"`       // 购买数量
	Cover      *string    `gorm:"" json:"cover"`         // 截图
	DesignId   *int64     `gorm:"" json:"design_id"`     // 设计ID
	Ctime      *int64     `gorm:"" json:"ctime"`         // 添加时间
	Status     *int64     `gorm:"" json:"status"`        // 状态位
	OptionalId *int64     `gorm:"" json:"optional_id"`   // 选项ID
	IsCheck    *int64     `gorm:"" json:"is_check"`      // 是否选中状态（0：未选中，1：选中）
	TsTime     *time.Time `gorm:"" json:"ts_time"`       //
	IsEmail    *int64     `gorm:"" json:"is_email"`      // 是否发送邮件
}
type FsCartModel struct{ db *gorm.DB }

func NewFsCartModel(db *gorm.DB) *FsCartModel { return &FsCartModel{db} }
