package model

import (
	"gorm.io/gorm"
)

type FsTags struct {
	Id                   int64   `gorm:"primary_key" json:"id"`          // ID
	Title                *string `gorm:"" json:"title"`                  // 标题
	Level                *int64  `gorm:"" json:"level"`                  // 层级、分类 1 => 二维码分类
	ClickNum             *int64  `gorm:"" json:"click_num"`              // 点击次数
	Sort                 *int64  `gorm:"" json:"sort"`                   // 排序(从大到小)
	CreateAt             *int64  `gorm:"" json:"create_at"`              // 创建时间
	Icon                 *string `gorm:"" json:"icon"`                   // 标签图标
	Status               *int64  `gorm:"" json:"status"`                 // 状态 1：可用
	Description          *string `gorm:"" json:"description"`            // 介绍 Seo
	RecommendProduct     *string `gorm:"" json:"recommend_product"`      // 推荐产品id例如: 1,3,4,5
	RecommendProductSort *string `gorm:"" json:"recommend_product_sort"` // 推荐排序例如:1324
}
type FsTagsModel struct{ db *gorm.DB }

func NewFsTagsModel(db *gorm.DB) *FsTagsModel { return &FsTagsModel{db} }
