package main

import (
	"flag"
	"fmt"

	"fusenapi/server/home-user-auth/internal/config"
	"fusenapi/server/home-user-auth/internal/handler"
	"fusenapi/server/home-user-auth/internal/svc"

	"github.com/zeromicro/go-zero/core/conf"
	"github.com/zeromicro/go-zero/rest"
)

var configFile = flag.String("f", "etc/home-user-auth.yaml", "the config file")

func main() {
	flag.Parse()

	var c config.Config
	conf.MustLoad(*configFile, &c)

	server := rest.MustNewServer(c.RestConf)
	defer server.Stop()

	ctx := svc.NewServiceContext(c)
	handler.RegisterHandlers(server, ctx)

	fmt.Printf("Starting server at %s:%d...\n", c.Host, c.Port)
	server.Start()
}

// 测试代码 可以直接复制新建

// var testConfigFile = flag.String("f", "../etc/home-user-auth.yaml", "the config file")
// var cnf config.Config

// func GetTestServer() *rest.Server {
// 	flag.Parse()

// 	conf.MustLoad(*testConfigFile, &cnf)

// 	server := rest.MustNewServer(cnf.RestConf)
// 	defer server.Stop()

// 	ctx := svc.NewServiceContext(cnf)
// 	handler.RegisterHandlers(server, ctx)

// 	fmt.Printf("Starting server at %s:%d...\n", cnf.Host, cnf.Port)
// 	return server
// }
